-module(smath).
-export([init_server/1, loop/2]).

init_server(Count) ->
    Count.

loop(Count, {factorial, N}) ->
    {factorial(N), Count+1};

loop(Count, {get_count}) ->
    {Count, Count}.

%Auxiliary functions to compute the factorial
nonTailRecursiveFactorial(0) ->
    1;
nonTailRecursiveFactorial(N) when N > 0 ->
    N * nonTailRecursiveFactorial(N-1).

factorial(N) ->
    tail_factorial(N,1).

tail_factorial(0, Acc) ->
    Acc;
tail_factorial(N, Acc) when N > 0 ->
    tail_factorial(N-1, Acc*N).
